/*
 * NMEAConverter.java
 *
 * Created on 28. Juni 2008, 14:08
 */
package de.k621.avr.gps.converter;

import java.io.*;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import java.util.Vector;

/**
 *
 * @author  Martin
 */
public class NMEAConverter extends javax.swing.JFrame {

    /** Creates new form NMEAConverter */
    public NMEAConverter() {
        try {
            UIManager.setLookAndFeel(
                    UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }

        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtInput = new javax.swing.JTextField();
        lblTitle = new javax.swing.JLabel();
        lblInput = new javax.swing.JLabel();
        btnBrowseInput = new javax.swing.JButton();
        btnKML = new javax.swing.JButton();
        lblFilter = new javax.swing.JLabel();
        chkValid = new javax.swing.JCheckBox();
        chkChecksum = new javax.swing.JCheckBox();
        btnElevationTable = new javax.swing.JButton();
        btnSpeed = new javax.swing.JButton();
        chkSat = new javax.swing.JCheckBox();
        lblSats = new javax.swing.JLabel();
        comSats = new javax.swing.JComboBox();
        chkHdop = new javax.swing.JCheckBox();
        comHdop = new javax.swing.JComboBox();
        lblInfo2 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        lblHomepage = new javax.swing.JLabel();
        lblAuthor = new javax.swing.JLabel();
        chkEveryNth = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("NMEA Toolbox");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);

        txtInput.setEditable(false);
        txtInput.setText("Bitte wählen sie eine Datei aus...");

        lblTitle.setFont(new java.awt.Font("Candara", 0, 36)); // NOI18N
        lblTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTitle.setText("NMEA Toolbox V1.0d");

        lblInput.setLabelFor(txtInput);
        lblInput.setText("Bitte Eingangs-Datei auswählen :");

        btnBrowseInput.setText("Durchsuchen...");
        btnBrowseInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseInputActionPerformed(evt);
            }
        });

        btnKML.setText("Google Earth/Maps KML Datei erstellen (mit Hilfe von $GPGGA Nachrichten)");
        btnKML.setActionCommand("Google Earth/Maps KML Datei erstellen (mit Hilfe von $GPGGA Nachrichten)");
        btnKML.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnKMLActionPerformed(evt);
            }
        });

        lblFilter.setText("Filter-Auswahl :");

        chkValid.setSelected(true);
        chkValid.setText("Ungültige Punkte verwerfen");

        chkChecksum.setSelected(true);
        chkChecksum.setText("Prüfsummen vergleichen");

        btnElevationTable.setText("Höhendiagramm erstellen (mit Hilfe von $GPGGA Nachrichten)");
        btnElevationTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnElevationTableActionPerformed(evt);
            }
        });

        btnSpeed.setText("Geschwindigkeitsdiagramm erstellen (mit Hilfe von $GPVTG Nachrichten)");
        btnSpeed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSpeedActionPerformed(evt);
            }
        });

        chkSat.setText("Nur Punkte mit mindestens");

        lblSats.setLabelFor(chkSat);
        lblSats.setText("Satteliten nehmen");

        comSats.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12" }));

        chkHdop.setText("Nur Punkte mit geringerem HDOP als");

        comHdop.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1.0 (Best)", "3.5", "6", "8.5", "11 (Worst)" }));
        comHdop.setSelectedIndex(2);

        lblInfo2.setText("Nur bei GGA-Nachrichten :");

        lblHomepage.setFont(new java.awt.Font("Tahoma", 1, 14));
        lblHomepage.setText("k621.de");

        lblAuthor.setFont(new java.awt.Font("Tahoma", 1, 14));
        lblAuthor.setText("Martin Matysiak");

        chkEveryNth.setSelected(true);
        chkEveryNth.setText("Punktezahl auf 350 reduzieren (Notw. für Google Maps Import)");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(chkEveryNth)
                    .addComponent(chkChecksum)
                    .addComponent(chkValid)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(chkSat)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(comSats, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblSats))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(chkHdop)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(comHdop, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnSpeed, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .addComponent(lblTitle, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .addComponent(btnElevationTable, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .addComponent(btnKML, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblInfo2)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(lblAuthor)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 227, Short.MAX_VALUE)
                        .addComponent(lblHomepage))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblInput)
                            .addComponent(txtInput, javax.swing.GroupLayout.DEFAULT_SIZE, 278, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBrowseInput))
                    .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .addComponent(lblFilter))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTitle)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblHomepage)
                    .addComponent(lblAuthor))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblInput)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnBrowseInput)
                    .addComponent(txtInput, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblFilter)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkValid)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkChecksum)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkEveryNth)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(lblInfo2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chkSat)
                    .addComponent(comSats, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblSats))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(comHdop, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(chkHdop))
                .addGap(18, 18, 18)
                .addComponent(btnKML)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnElevationTable)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnSpeed)
                .addGap(15, 15, 15))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnKMLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnKMLActionPerformed

    //Assign the Input & Output File
    try {
        if (!(new File(txtInput.getText()).exists())) {
            throw new IOException("Please choose a exsisting input file!");
        }

        JFileChooser fileChooser = new JFileChooser();
        String outFile = "NO_FILE";
        
        fileChooser.setAcceptAllFileFilterUsed(false);
        fileChooser.setFileFilter(new FileTypeFilter("kml"));

        if (fileChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            outFile = (fileChooser.getSelectedFile().getAbsolutePath());
        } else {
            throw new IOException("No Output file was selected");
        }
        
        if (!outFile.endsWith(".kml") ) {
            outFile += ".kml";
        }

        if (new File(outFile).exists()) {
            throw new IOException("Please choose a non-exsisting output file!");
        }

        BufferedReader input = new BufferedReader(
                new FileReader(
                new File(txtInput.getText())));
        BufferedWriter output = new BufferedWriter(
                new FileWriter(
                new File(outFile)));

        //Write Header of KML File
        output.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
                "<kml xmlns=\"http://earth.google.com/kml/2.1\">\n" +
                "\t<Placemark>\n" +
                "\t\t<name>GPS Tracked Path</name>\n" +
                "\t\t<description>Created on ::DATUM:: with NMEA-Toolbox by Kaktus621 :: www.k621.de</description>\n" +
                "\t\t<Style id=\"redLine\">\n" +
                "\t\t\t<LineStyle>\n" +
                "\t\t\t\t<color>ff0060ff</color>\n" +
                "\t\t\t\t<width>4</width>\n" +
                "\t\t\t</LineStyle>\n" +
                "\t\t</Style>\n" +
                "\t\t<styleUrl>#redLine</styleUrl>\n" +
                "\t\t<LineString>\n" +
                "\t\t\t<extrude>0</extrude>\n" +
                "\t\t\t<tessellate>1</tessellate>\n" +
                "\t\t\t<altitudeMode>clampToGround</altitudeMode>\n" +
                "\t\t\t<coordinates>");

        //Process Inputs
        Vector<String> outLines = new Vector<String>();
        String inLine = input.readLine();

        while (inLine != null && !inLine.isEmpty()) {
            boolean discardMessage = false;

            //Discard Messages that are not $GPGGA
            if (!inLine.startsWith("$GPGGA")) {
                discardMessage = true;
            }

            if (!discardMessage && chkChecksum.isSelected()) {
                discardMessage = !isValidMsg(inLine);
            }

            //If Message is Valid, tokenize it
            if (!discardMessage) {
                GGAMessage message = new GGAMessage(inLine);


                //## FILTER TWO ## : Check if Message is a Valid one
                if (chkValid.isSelected() && !message.isValid()) {
                    discardMessage = true;
                }

                //## FILTER THREE ## : Check if there were enough sattelites
                if (chkSat.isSelected() && !message.hasSattelites(comSats.getSelectedIndex() + 1)) {
                    discardMessage = true;
                }

                //If Message has succeeded all Filter tests, write into Vector
                if (!discardMessage) {
                    outLines.add(" " + message.getLongitude(GGAMessage.DEGREES) + "," + message.getLatitude(GGAMessage.DEGREES) + "\n\t\t\t");
                    //output.write(" " + message.getLongitude(GGAMessage.DEGREES) + "," + message.getLatitude(GGAMessage.DEGREES) + "\n\t\t\t");
                }
            }

            inLine = input.readLine();
        }
        
        //Write Vector into File, discard some points if requested
        int takePoint = 1;
        
        if (chkEveryNth.isSelected()) {
            takePoint = outLines.size() / 350; //300 is the highest possible size for gMaps
        }
        
        for(int i = 0; i < outLines.size(); i++) {
            if (i % takePoint == 0) {
                output.write(outLines.get(i));
            }
        }
        

        //Write Footer
        output.write("</coordinates>\n" +
                "\t\t</LineString>\n" +
                "\t</Placemark>\n" +
                "</kml>");

        output.close();

        JOptionPane.showMessageDialog(this, "The KML File has been successfully created!", "Success!", JOptionPane.INFORMATION_MESSAGE);

    } catch (Exception ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
    }

}//GEN-LAST:event_btnKMLActionPerformed

private void btnBrowseInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseInputActionPerformed
// TODO add your handling code here:
    JFileChooser fileChooser = new JFileChooser();

    if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        txtInput.setText(fileChooser.getSelectedFile().getAbsolutePath());
    }

}//GEN-LAST:event_btnBrowseInputActionPerformed

private void btnElevationTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnElevationTableActionPerformed
// TODO add your handling code here:
    JFileChooser fileChooser = new JFileChooser();
    String outCsv = "NO\\FILE";

    try {

        fileChooser.setAcceptAllFileFilterUsed(false);
        fileChooser.setFileFilter(new FileTypeFilter("csv"));

        if (fileChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            outCsv = fileChooser.getSelectedFile().getAbsolutePath();
        } else {
            throw new IOException("No Output file was selected");
        }

        if (outCsv.equals("NO\\FILE")) {
            throw new Exception("The saving location could not be stored!");
        }
        
        if (!outCsv.endsWith(".csv") ) {
            outCsv += ".csv";
        }

        if (new File(outCsv).exists()) {
            throw new Exception("Plese choose only non-exsisting Files for the output!");
        }

        //Dateien öffnen
        BufferedReader input = new BufferedReader(
                new FileReader(
                new File(txtInput.getText())));

        BufferedWriter output = new BufferedWriter(
                new FileWriter(
                new File(outCsv)));


        //Positionsangaben einlesen und in Tabelle ablegen, gleichzeitig auch Minima und Maxima ermitteln
        float minAlt = 99999, maxAlt = 0;
        String inLine = "#";
        int i = 0;
        
        while (inLine != null && !inLine.isEmpty()) {
            boolean discardMessage = false;

            //Discard Messages that are not $GPGGA
            if (!inLine.startsWith("$GPGGA")) {
                discardMessage = true;
            }

            if (!discardMessage && chkChecksum.isSelected()) {
                discardMessage = !isValidMsg(inLine);
            }

            //If Message is Valid, tokenize it
            if (!discardMessage) {
                GGAMessage message = new GGAMessage(inLine);


                //## FILTER TWO ## : Check if Message is a Valid one
                if (chkValid.isSelected() && !message.isValid()) {
                    discardMessage = true;
                }

                //## FILTER THREE ## : Check if there were enough sattelites
                if (chkSat.isSelected() && !message.hasSattelites(comSats.getSelectedIndex() + 1)) {
                    discardMessage = true;
                }

                //## FILTER FOUR ## : Check HDOP
                if (chkHdop.isSelected() && !message.hasLowerHdopThan((float) (1 + (comHdop.getSelectedIndex() * 0.1)))) {
                    discardMessage = true;
                }

                //If Message has succeeded all Filter tests, write into File
                if (!discardMessage) {
                    if (message.getAltitude() < minAlt) {
                        minAlt = message.getAltitude();
                    }

                    if (message.getAltitude() > maxAlt) {
                        maxAlt = message.getAltitude();
                    }

                    output.write(/*message.getTime(GGAMessage.RAW).replace('.', ',')*/ i++ + ";" + Float.toString(message.getAltitude()).replace('.', ',') + "\n");
                }
            }

            inLine = input.readLine();
        }

        output.close();
    } catch (Exception ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
    }
}//GEN-LAST:event_btnElevationTableActionPerformed

private void btnSpeedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSpeedActionPerformed
// TODO add your handling code here:
    JFileChooser fileChooser = new JFileChooser();
    String outCsv = "NO\\FILE";

    try {

        fileChooser.setAcceptAllFileFilterUsed(false);
        fileChooser.setFileFilter(new FileTypeFilter("csv"));

        if (fileChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            outCsv = fileChooser.getSelectedFile().getAbsolutePath();
        } else {
            throw new IOException("No Output file was selected");
        }

        if (outCsv.equals("NO\\FILE")) {
            throw new Exception("The saving location could not be stored!");
        }

        
        if (!outCsv.endsWith(".csv") ) {
            outCsv += ".csv";
        }
        
        if (new File(outCsv).exists()) {
            throw new Exception("Plese choose only non-exsisting Files for the output!");
        }

        //Dateien öffnen
        BufferedReader input = new BufferedReader(
                new FileReader(
                new File(txtInput.getText())));

        BufferedWriter output = new BufferedWriter(
                new FileWriter(
                new File(outCsv)));


        //Geschwindigkeiten
        String inLine = "#";
        int counter = 1;

        while (inLine != null && !inLine.isEmpty()) {
            boolean discardMessage = false;

            //Discard Messages that are not $GPVTG
            if (!inLine.startsWith("$GPVTG")) {
                discardMessage = true;
            }

            if (!discardMessage && chkChecksum.isSelected()) {
                discardMessage = !isValidMsg(inLine);
            }

            //If Message is Valid, tokenize it
            if (!discardMessage) {
                VTGMessage message = new VTGMessage(inLine);


                //## FILTER TWO ## : Check if Message is a Valid one
                if (chkValid.isSelected() && !message.isValid()) {
                    discardMessage = true;
                }

                //If Message has succeeded all Filter tests, write into File
                if (!discardMessage) {
                    output.write(counter++ + ";" + Float.toString(message.getSpeed()).replace('.', ',') + "\n");
                }
            }

            inLine = input.readLine();
        }

        output.close();
    } catch (Exception ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
    }
}//GEN-LAST:event_btnSpeedActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new NMEAConverter().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBrowseInput;
    private javax.swing.JButton btnElevationTable;
    private javax.swing.JButton btnKML;
    private javax.swing.JButton btnSpeed;
    private javax.swing.JCheckBox chkChecksum;
    private javax.swing.JCheckBox chkEveryNth;
    private javax.swing.JCheckBox chkHdop;
    private javax.swing.JCheckBox chkSat;
    private javax.swing.JCheckBox chkValid;
    private javax.swing.JComboBox comHdop;
    private javax.swing.JComboBox comSats;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JLabel lblAuthor;
    private javax.swing.JLabel lblFilter;
    private javax.swing.JLabel lblHomepage;
    private javax.swing.JLabel lblInfo2;
    private javax.swing.JLabel lblInput;
    private javax.swing.JLabel lblSats;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JTextField txtInput;
    // End of variables declaration//GEN-END:variables

    private boolean isValidMsg(String line) {
        //## FILTER ONE ## : Calculate Checksum
        byte checksum = 0;
        int i = 1;
        boolean end = false;

        for (i = 1; (i < line.length()) && (!end); i++) {
            if (line.charAt(i) != '*') {
                checksum ^= line.charAt(i);
            } else {
                end = true;
            }
        }

        byte givenSum = 0;
        
        try { givenSum = Byte.parseByte(line.substring(i), 16); } catch (Exception ex) { givenSum = 0; }

        if (checksum != givenSum) {
            return false;
        } else {
            return true;
        }
    }
    
}


class FileTypeFilter extends javax.swing.filechooser.FileFilter {

    private String type = "";
    
    public FileTypeFilter(String type) {
        this.type = type;
    }
    
    public boolean accept(File pathname) {
        if (pathname.isDirectory()) {
            return true;
        }
        
        if (pathname.getName().toLowerCase().endsWith(type.toLowerCase())) {
            return true;
        } else {
            return false;
        }
    }
    
    public String getDescription() {
        return (type.toUpperCase() + " files (*." + type + ")");
    }    
}

class VTGMessage {
    private float speed = 0;
    private String validCode = "N";
    
    public VTGMessage(String rawString) {
        String[] rawData = rawString.split(",");
        
        try { speed = Float.parseFloat(rawData[7]); } catch (Exception ex) { speed = 0; }
        validCode = rawData[8];
    }
    
    public float getSpeed() {
        return speed;
    }
    
    public boolean isValid() {
        if (validCode.equals("N")) {
            return false;
        } else {
            return true;
        }
            
    }
}

class GGAMessage {
    private String rawTime = "";
    private String rawLat = "0000.0000", rawLon = "0000.0000";
    private char latIndicator = '0', lonIndicator = '0';
    private int fix = 0, sat = 0;
    private float alt = 0, hdop = 0;
    
    public static final int RAW = 0;
    public static final int DEG_MIN_SEC = 1;
    public static final int DEGREES = 2;
    public static final int HHMMSS = 4;
    
    public GGAMessage(String rawString) {
        String[] rawData = rawString.split(",");

        rawTime = rawData[1];
        if (!rawData[2].isEmpty()) 
            rawLat = rawData[2];
        
        if (!rawData[3].isEmpty())
            latIndicator = rawData[3].charAt(0);
        
        if (!rawData[4].isEmpty())
            rawLon = rawData[4];
        
        if (!rawData[5].isEmpty())
            lonIndicator = rawData[5].charAt(0);
        
        try { fix = Integer.parseInt(rawData[6]); } catch (Exception ex) { fix = 0; }
        try { sat = Integer.parseInt(rawData[7]); } catch (Exception ex) { sat = 0; }
        try { hdop = Float.parseFloat(rawData[8]); } catch (Exception ex) { hdop = 0; }
        try { alt = Float.parseFloat(rawData[9]); } catch (Exception ex) { alt = 0; }
    }
    
    public String getLatitude(int format) {
        switch(format) {
            case RAW :
                return rawLat + " " + latIndicator;
            case DEGREES :
                float output = 0;
                output = Float.parseFloat(rawLat.substring(0,2));
                output += Float.parseFloat(rawLat.substring(2)) / 60;
                if (latIndicator == 'S') {
                    output *= -1;
                }
                return Float.toString(output);
            default :
                return rawLat + " " + latIndicator;
        }
    }
    
    public String getLongitude(int format) {
        switch(format) {
            case RAW :
                return rawLon + " " + lonIndicator;
            case DEGREES :
                float output = 0;
                output = Float.parseFloat(rawLon.substring(0,3));
                output += Float.parseFloat(rawLon.substring(3)) / 60;
                if (lonIndicator == 'W') {
                    output *= -1;
                }
                return Float.toString(output);
            default :
                return rawLon + " " + lonIndicator;
        }
    }
    
    public float getAltitude() {
        return alt;
    }
    
    public String getTime(int format) {
        switch(format) {
            case RAW : 
                return rawTime;
            default :
                return rawTime;
        }
    }
    
    public boolean isValid() {
        return fix >= 1 ? true : false;
    }
    
    public boolean hasSattelites(int count) {
        return sat >= count ? true : false;
    }
    
    public boolean hasLowerHdopThan(float inHdop) {
        return hdop <= inHdop ? true : false;
    }
}